/*
	ZazouMiniWebServer

	Copyright (C) 2003-2011 Xavier Garreau <xavier@xgarreau.org>

	This file is part of ZazouMiniWebServer.

    ZazouMiniWebServer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ZazouMiniWebServer is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZazouMiniWebServer; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
	
#ifndef _ZMWS_MIME_H
#define _ZMWS_MIME_H 1


typedef std::pair<std::string, std::string> MIME_TYPE;
typedef std::map<std::string, std::string> MIME_TYPES_MAP;
class ZMWSMIME
{
    static std::string defaultMIME;
	MIME_TYPES_MAP mime_types;
public:
    void setDefaultMimeType(const std::string& type);
	const std::string getMimeType(const std::string& extension);
	void addMimeType(const std::string& extension, const std::string& type);
	ZMWSMIME(void);
	~ZMWSMIME(void);
};

#endif 

