/*
	ZazouModSSL

	Copyright (C) 2003-2009 Xavier Garreau <xavier@xgarreau.org>

	This file is part of ZazouModSSL.

    ZazouMiniWebServer is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ZazouModSSL is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ZazouModSSL; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

	In addition, as a special exception, Xavier Garreau gives permission
	to link the code of this program with the OpenSSL library
	(or with modified versions of OpenSSL that use the same license as OpenSSL),
	and distribute linked combinations including the two.
	You must obey the GNU General Public License in all respects for all
	of the code used other than OpenSSL. If you modify this file, you may
	extend this exception to your version of the file, but you are not
	obligated to do so. If you do not wish to do so, delete this exception
	statement from your version. 
*/

#ifndef _ZMWS_MODSSL_H
#define _ZMWS_MODSSL_H 1


typedef void*			ZazouModData_t;
typedef int				(*fnInitialize_t)	();
typedef int				(*fnUninitialize_t)	();
typedef ZazouModData_t	(*fnAccept_t)		(int fd);
typedef int				(*fnClose_t)		(ZazouModData_t ssl);
typedef int				(*fnRead_t)			(ZazouModData_t ssl, LPBYTE data, DWORD datalen);
typedef int				(*fnWrite_t)		(ZazouModData_t ssl, LPBYTE data, DWORD datalen);

typedef struct _ZazouModSsl_Functions
{
	fnInitialize_t	fnInitialize;
	fnAccept_t		fnAccept;
	fnClose_t		fnClose;
	fnRead_t		fnRead;
	fnWrite_t		fnWrite;
} ZazouModSsl_Functions;

typedef ZazouModSsl_Functions (*ZazouModSslLoad_t)(void);

#endif
